package com.fr.plugin.decision.dialect.postgre;

import com.fr.data.core.db.dialect.Dialect;
import com.fr.data.core.db.dialect.base.key.column.typetosql.AbstractDialectColumnType2SQLExecutor;
import com.fr.data.core.db.dialect.base.key.column.typetosql.DialectColumnType2SQLParameter;
import com.fr.data.core.db.dialect.util.DialectUtils;

public class PostgreDialectColumnType2SQLExecutor extends AbstractDialectColumnType2SQLExecutor {
    public PostgreDialectColumnType2SQLExecutor(){

    }

    @Override
    public String execute(DialectColumnType2SQLParameter dialectColumnType2SQLParameter, Dialect dialect) {
        int columnType = dialectColumnType2SQLParameter.getColumnType();
        String columnSize = dialectColumnType2SQLParameter.getParameter();
        switch(columnType) {
            case 8:
                return "double precision";
            case 12:
                return "varchar(" + columnSize + ")";
            case 91:
                return "date";
            default:
                return DialectUtils.getTypeName(columnType);
        }
    }
}
