!(function () {
    var UpgradePane = BI.inherit(BI.Widget, {
        props: {
            baseCls: "dec-mng-check"
        },

        _store: function () {
            return BI.Models.getModel("dec.model.mng.check");
        },

        watch: {
            result: function (items) {
                this.list.populate(this._createItems(items));
                this.count.setText("excel表总数: " + BI.size(items));
            }
        },

        render: function () {
            var self = this;
            return {
                type: "bi.vertical",
                width: 640,
                hgap: 50,
                vgap: 50,
                items: [{
                    type: "bi.center_adapt",
                    items: [{
                        type: "bi.button",
                        width: 200,
                        text: "检测所有excel的大小",
                        handler: self.store.getResult
                    }]
                }, {
                    type: "bi.center_adapt",
                    items: [{
                        type: "bi.label",
                        text: "excel表总数: 0",
                        ref: function (_ref) {
                            self.count = _ref;
                        }
                    }]
                }, {
                    type: "bi.vertical",
                    ref: function (_ref) {
                        self.list = _ref;
                    }
                }]
            };
        },

        _createItems: function (items) {
            return BI.map(items, function (idx, item) {
                var text = "【" + item.transferName + "】数据量: " + item.rowCount;
                return {
                    type: "bi.horizontal",
                    items: [{
                        type: "bi.label",
                        textAlign: "left",
                        text: text
                    }]
                }
            });
        }
    });
    BI.shortcut("dec.mng.check", UpgradePane);
})();